[BACK]Return to fw_install.sh CVS log [TXT][DIR] Up to [local] / openbsd / fw_update

Diff for /openbsd/fw_update/fw_install.sh between version 1.7 and 1.74

version 1.7, 2021/10/14 03:00:02 version 1.74, 2021/12/11 20:57:51
Line 1 
Line 1 
 #!/bin/ksh  #!/bin/ksh
 set -e  #       $OpenBSD$
   #
   # Copyright (c) 2021 Andrew Hewus Fresh <afresh1@openbsd.org>
   #
   # Permission to use, copy, modify, and distribute this software for any
   # purpose with or without fee is hereby granted, provided that the above
   # copyright notice and this permission notice appear in all copies.
   #
   # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
   # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
   # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
   # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
   # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
   # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
   # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
   
 scan_dmesg() {  set -o errexit -o pipefail -o nounset
         # no bsort for now  
         sed -n "$1" /var/run/dmesg.boot  
 }  
   
 installed_firmware() {  CFILE=SHA256.sig
         for fw in ${PKGDIR}/$1-firmware*; do  DESTDIR=${DESTDIR:-}
                 [ -e "$fw" ] || continue  FWPATTERNS="${DESTDIR}/usr/share/misc/firmware_patterns"
                 echo ${fw##*/}  
         done  
 }  
   
 # do_as, unpriv, and unpriv2 are from install.sub  VNAME=${VNAME:-$(sysctl -n kern.osrelease)}
   VERSION=${VERSION:-"${VNAME%.*}${VNAME#*.}"}
   
 # Run a command ($2+) as unprivileged user ($1).  HTTP_FWDIR="$VNAME"
 # Take extra care that after "cmd" no "user" processes exist.  VTYPE=$( sed -n "/^OpenBSD $VNAME\([^ ]*\).*$/s//\1/p" \
 #      /var/run/dmesg.boot | sed '$!d' )
 # Optionally:  [[ $VTYPE == -!(stable) ]] && HTTP_FWDIR=snapshots
 #       - create "file" and chown it to "user"  
 #       - after "cmd", chown "file" back to root  
 #  
 # Usage: do_as user [-f file] cmd  
 do_as() {  
         (( $# >= 2 )) || return  
   
         local _file _rc _user=$1  FWURL=http://firmware.openbsd.org/firmware/${HTTP_FWDIR}
         shift  FWPUB_KEY=${DESTDIR}/etc/signify/openbsd-${VERSION}-fw.pub
   
         if [[ $1 == -f ]]; then  LOCALSRC=
                 _file=$2  
                 shift 2  
         fi  
   
         if [[ -n $_file ]]; then  tmpdir() {
                 >$_file          local _i=1 _dir
                 chown "$_user" "$_file"  
           # If we're not in the installer,
           # we have mktemp and a more hostile environment
           if [ -x /usr/bin/mktemp ]; then
                   _dir=$( mktemp -d "${1}-XXXXXXXXX" )
           else
                   until _dir="${1}.$_i.$RANDOM" && mkdir -- "$_dir" 2>/dev/null; do
                       ((++_i < 10000)) || return 1
                   done
         fi          fi
   
         doas -u "$_user" "$@"          echo "$_dir"
         _rc=$?  }
   
         while doas -u "$_user" kill -9 -1 2>/dev/null; do  fetch() {
                 echo "Processes still running for user $_user after: $@"          local _src="${FWURL}/${1##*/}" _dst=$1 _user=_file _exit
                 sleep 1  
         done  
   
         [[ -n $_file ]] && chown root "$_file"          # If we're not in the installer, we have su(1)
           # and doas(1) is unlikely to be configured.
           if [ -x /usr/bin/su ]; then
                   /usr/bin/su -s /bin/ksh "$_user" -c \
                       "/usr/bin/ftp -D 'Get/Verify' -Vm -o- '$_src'" > "$_dst"
                   _exit="$?"
           else
                   /usr/bin/doas -u "$_user" \
                       /usr/bin/ftp -D 'Get/Verify' -Vm -o- "$_src" > "$_dst"
                   _exit="$?"
           fi
   
         return $_rc          if [ "$_exit" -ne 0 ]; then
                   rm -f "$_dst"
                   echo "Cannot fetch $_src" >&2
                   return 1
           fi
 }  }
   
 unpriv() {  verify() {
         do_as _sndio "$@"          # On the installer we don't get sha256 -C, so fake it.
           if ! fgrep -qx "SHA256 (${1##*/}) = $( /bin/sha256 -qb "$1" )" "$CFILE"; then
                   echo "Checksum test for ${1##*/} failed." >&2
                   return 1
           fi
 }  }
   
 unpriv2() {  devices_needing_firmware() {
         do_as _file "$@"          local _d _m _grep _dmesgtail _last=''
 }  
   
 VNAME=$(sysctl -n kern.osrelease)          # When we're not in the installer, the dmesg.boot can
 VERSION="${VNAME%.*}${VNAME#*.}"          # contain multiple boots, so only look in the last one
 FWDIR="$VNAME"          _dmesgtail=$( sed -n 'H;/^OpenBSD/h;${g;p;}' /var/run/dmesg.boot )
   
 HTTP_FWDIR=$FWDIR          grep -v '^[[:space:]]*#' "$FWPATTERNS" |
 set -- $(scan_dmesg "/^OpenBSD $VNAME\([^ ]*\).*$/s//\1/p")              while read -r _d _m; do
 [[ $1 == -!(stable) ]] && HTTP_FWDIR=snapshots                  _grep="grep"
                   [ "$_last" = "$_d" ] && continue
                   [ "$_m" ] || _m="^${_d}[0-9][0-9]* at "
                   [ "$_m" = "${_m#^}" ] && _grep="fgrep"
   
 FWURL=http://firmware.openbsd.org/firmware/${HTTP_FWDIR}                  echo "$_dmesgtail" | $_grep -q "$_m" || continue
 FWPUB_KEY=${DESTDIR}/etc/signify/openbsd-${VERSION}-fw.pub                  echo "$_d"
 PKGDIR=${DESTDIR}/var/db/pkg                  _last="$_d"
 PATTERNS="file:${0%/*}/firmware_patterns"          done
   }
   
 drivers=$(  firmware_filename() {
         last=''          local _f
         ftp -D "Detecting" -Vmo- $PATTERNS |          _f="$( sed -n "s/.*(\($1-firmware-.*\.tgz\)).*/\1/p" "$CFILE" | sed '$!d' )"
         while read d m; do          ! [ "$_f" ] && echo "Unable to find firmware for $1" >&2 && return 1
                 grep=grep          echo "$_f"
                 [ "$last" = "$d" ] && continue  }
                 [ "$m" ] || m="^$d[0-9][0-9]* at "  
                 [ "$m" = "${m#^}" ] && grep=fgrep  firmware_devicename() {
                 $grep -q "$m" /var/run/dmesg.boot || continue          local _d="${1##*/}"
                 echo $d          _d="${_d%-firmware-*}"
                 last=$d          echo "$_d"
   }
   
   installed_firmware() {
           for fw in "${DESTDIR}/var/db/pkg/$1-firmware"*; do
                   [ -e "$fw" ] || continue
                   echo "${fw##*/}"
         done          done
 )  }
   
 if [ -z "$drivers" ]; then  add_firmware () {
         echo "No devices found which need firmware files to be downloaded." >&2          local _f="${1##*/}"
         exit 0          local _pkgdir="${DESTDIR}/var/db/pkg/${_f%.tgz}"
 fi          ftp -D "Install" -Vmo- "file:${1}" |
                   tar -s ",^\+,${_pkgdir}/+," \
                       -s ",^firmware,${DESTDIR}/etc/firmware," \
                       -C / -zxphf - "+*" "firmware/*"
   
 tmpdir=${DESTDIR}/tmp/fw_update          # TODO: Should we mark these so real fw_update can -Drepair?
 [ -e "$tmpdir" ] && rm -rf "$tmpdir"          ed -s "${_pkgdir}/+CONTENTS" <<EOL
 mkdir -p "$tmpdir"  /^@comment pkgpath/ -1a
 cd "$tmpdir"  @option manual-installation
   @option firmware
   @comment install-script
   .
   w
   EOL
   }
   
 # TODO: Drop privs during fetch and verify  delete_firmware() {
 ftp -D Get -Vm "$FWURL/SHA256.sig"          local _cwd _pkg="$1" _pkgdir="${DESTDIR}/var/db/pkg"
   
 # Probably should bundle the firmware sigfile on the installer,          # TODO: Check hash for files before deleting
 # although we can just get it from the recently installed system.          echo "Uninstalling $_pkg"
 if [ "$DESTDIR" ]; then          _cwd="${_pkgdir}/$_pkg"
         sigfile=$( sed -n '/^untrusted comment: verify with \(.*\)$/ { s//\1/p; q; }' SHA256.sig )  
         if [ ! -e "/etc/signify/$sigfile" ] \  
           && [ -e "${DESTDIR}/etc/signify/$sigfile" ]; then  
                 cp -a "${DESTDIR}/etc/signify/$sigfile" "/etc/signify/$sigfile"  
         fi  
 fi  
   
 signify -Ve -x SHA256.sig -m - < SHA256.sig > SHA256          set -A _remove -- "${_cwd}/+CONTENTS" "${_cwd}"
   
 for d in $drivers; do          while read -r c g; do
         firmware=$( sed -n "s/.*(\($d-firmware-.*\.tgz\)).*/\1/p" SHA256 )                  case $c in
         installed=$( installed_firmware $d )                  @cwd) _cwd="${DESTDIR}$g"
                     ;;
                   @*) continue
                     ;;
                   *) set -A _remove -- "$_cwd/$c" "${_remove[@]}"
                     ;;
                   esac
           done < "${_pkgdir}/${_pkg}/+CONTENTS"
   
         for i in $installed; do          # We specifically rm -f here because not removing files/dirs
                 if [ "$firmware" = "$i.tgz" ]; then          # is probably not worth failing over.
                         echo "Firmware for $d already installed ($installed)"          for _r in "${_remove[@]}" ; do
                         continue 2                  if [ -d "$_r" ]; then
                           # Try hard not to actually remove recursively
                           # without rmdir on the install media.
                           [ "$_r/*" = "$( echo "$_r"/* )" ] && rm -rf "$_r"
                   else
                           rm -f "$_r"
                 fi                  fi
         done          done
   }
   
         mkdir $d  usage() {
           echo "usage: fw_install [-d dir | -L dir] [driver | file [...]]"
           exit 2
   }
   
         # TODO: Drop privs during fetch and verify  INSTALL=true
         ftp -D "Get/Verify" -Vmo- "$FWURL/$firmware" | sha256 -bph "$d/h" > "$firmware"  DOWNLOAD=true
         fgrep -qx "SHA256 ($firmware) = $(<$d/h)" SHA256  
   
         # TODO: Check hash for files before deleting  while getopts dL name
         if [ "$installed" ] && [ -e "${PKGDIR}/$installed/+CONTENTS" ]; then  do
                 echo "Uninstalling $installed"         case "$name" in
                 cwd=${PKGDIR}/$installed         # "download only" means local dir and don't install
          d) LOCALSRC=. INSTALL=false ;;
          L) LOCALSRC=. ;;
          ?) usage 2 ;;
          esac
   done
   shift $((OPTIND - 1))
   
                 remove="${cwd}/+CONTENTS ${cwd}"  # If we're installing from a local dir
   # we don't want to download anything
   [ "$LOCALSRC" ] && "$INSTALL" && DOWNLOAD=false
   [ "$LOCALSRC" ] || LOCALSRC="$( tmpdir "${DESTDIR}/tmp/fw_install" )"
   
                 while read c g; do  set -A devices -- "$@"
                         case $c in  
                         @cwd) cwd=$g  
                           ;;  
                         @*) continue  
                           ;;  
                         *)  remove="$cwd/$c $remove"  
                           ;;  
                         esac  
                 done < "${PKGDIR}/$installed/+CONTENTS"  
   
                 for r in $remove ; do  [ "${devices[*]:-}" ] ||
                         if [ -d "$r" ]; then      set -A devices -- $( devices_needing_firmware )
                                 # Try hard not to actually remove recursively  
                                 # without rmdir on the install media.  if [ ! "${devices[*]:-}" ]; then
                                 [ "$r/*" = $( echo "$r"/* ) ] && rm -rf "$r"          echo "No devices found which need firmware files to be downloaded."
                         else          exit
                                 rm -f "$r"  fi
   
   if "$DOWNLOAD"; then
           fetch "$CFILE"
           ! signify -qVep "$FWPUB_KEY" -x "$CFILE" -m "$CFILE" &&
               echo "Signature check of SHA256.sig failed" >&2 && exit 1
   fi
   
   for f in "${devices[@]}"; do
           d="$( firmware_devicename "$f" )"
   
           if [ "$f" = "$d" ]; then
                   f=$( firmware_filename "$d" || true )
                   [ "$f" ] || continue
                   f="$LOCALSRC/$f"
           elif ! "$INSTALL" && ! grep -q "($f)" "$CFILE" ; then
                   echo "Cannot download local file $f" >&2
                   exit 2
           fi
   
           set -A installed -- $( installed_firmware "$d" )
   
           if "$INSTALL" && [ "${installed[*]:-}" ]; then
                   for i in "${installed[@]}"; do
                           if [ "${f##*/}" = "$i.tgz" ]; then
                                   echo "$i already installed"
                                   continue 2
                         fi                          fi
                 done                  done
         fi          fi
   
         # TODO: Add some details about the install to +CONTENTS like pkg_add          if [ -e "$f" ]; then
         # TODO: Or, maybe we save the firmware someplace and make pkg_add reinstall                  if "$DOWNLOAD"; then
         echo "Installing $firmware"                          echo "Verify existing ${f##*/}"
         tar -zxphf "$firmware" -C /etc "firmware/*"                          verify "$f" || continue
         mkdir -p ${PKGDIR}/${firmware%.tgz}/                  # else assume it was verified when downloaded
         tar -zxphf "$firmware" -C "${PKGDIR}/${firmware%.tgz}" "+*"                  fi
         ed -s "${PKGDIR}/${firmware%.tgz}/+CONTENTS" <<EOL          elif "$INSTALL" && ! "$DOWNLOAD"; then
 /^@comment pkgpath/ -1a                  echo "Cannot install ${f##*/}, not found" >&2
 @option manual-installation                  continue
 @option firmware          else
 @comment install-script                  fetch  "$f" || continue
 .                  verify "$f" || continue
 w          fi
 EOL  
           "$INSTALL" || continue
   
           if [ "${installed[*]:-}" ]; then
                   for i in "${installed[@]}"; do
                           delete_firmware "$i"
                   done
           fi
   
           add_firmware "$f"
 done  done
   

Legend:
Removed from v.1.7  
changed lines
  Added in v.1.74

FreeBSD-CVSweb <freebsd-cvsweb@FreeBSD.org>